function DamageAcid(self)
  local checkPos = self.Pos + self.Vel;
  local checkPix = SceneMan:GetMOIDPixel(checkPos.X,checkPos.Y);
  if checkPix ~= 255 then
    checkPos = checkPos + SceneMan:ShortestDistance(checkPos,self.Pos,SceneMan.SceneWrapsX):SetMagnitude(3);
    self.target = MovableMan:GetMOFromID(checkPix);
    local actor = MovableMan:GetMOFromID(self.target.RootID);
    if MovableMan:IsActor(actor) and actor.ClassName ~= "ADoor" then
      actor = ToActor(actor)
    elseif actor.PresetName ~= "Skeleton" then
      local effect = CreateMOPixel("Acid Damage")
      effect.Pos = self.Pos + self.Vel
      effect.Vel = self.Vel.Normalized * 100
      MovableMan:AddParticle(effect);
    end
    if actor ~= nil and actor.Health ~= nil and self.ToDelete == false and actor.ToDelete == false then
      local testHealth = actor.Health
      if actor.ClassName == "AHuman" then
        local check = false
        if not (ToAHuman(actor).Head ~= nil and self.target.ID == ToAHuman(actor).Head.ID) and not self.target.ID == actor.ID then
          check = true
        end
        if check then
          testHealth = math.min(actor.Health , actor.Health * 0.5^(5/actor.Mass^2) - math.max(0 ,(48000-(self.Age*240))/actor.Mass^2.5))
        else
          testHealth = math.min(actor.Health , actor.Health * 0.5^(19/actor.Mass) - math.max(0 ,(75000-(self.Age*40))/actor.Mass^2))
        end
      else
        testHealth = math.min(actor.Health , actor.Health * 0.5^(9/actor.Mass^2) - math.max(0 ,(56000-(self.Age*120))/actor.Mass^2.5))
      end
      if math.random()>testHealth - math.floor(testHealth) then
        actor.Health = math.ceil(testHealth)
      else
        actor.Health = math.floor(testHealth)
      end
      if actor.ClassName == "AHuman" and actor.Health < 10 and actor.PresetName ~= "Skeleton" and not string.find(ToAHuman(actor).PresetName , "Robot") and not string.find(ToAHuman(actor).PresetName , "Dummy") then
        local skeleton = CreateAHuman("Skeleton");
        skeleton.Pos = actor.Pos
        skeleton.Vel = actor.Vel
        skeleton.Team = actor.Team
        skeleton.Health = actor.Health
        skeleton.RotAngle = actor.RotAngle
        skeleton.AngularVel = actor.AngularVel
        skeleton.HFlipped = actor.HFlipped
        MovableMan:AddActor(skeleton);
        if ToAHuman(actor).Head == nil then
          skeleton.Head.ToDelete = true
        else
          skeleton.Head.RotAngle = ToAHuman(actor).Head.RotAngle
          skeleton.Head.AngularVel = ToAHuman(actor).Head.AngularVel
          local effect = CreateMOSParticle("Acid Puff")
          effect.Pos = skeleton.Head.Pos
          effect.Vel = skeleton.Head.Vel
          effect.LifeTime = math.random(500, 1500)
          if math.random() > 0.5 then
            effect.HFlipped = true
          end
          MovableMan:AddParticle(effect);
        end
        if ToAHuman(actor).FGArm == nil then
          skeleton.FGArm.ToDelete = true
        else
          skeleton.FGArm.RotAngle = ToAHuman(actor).FGArm.RotAngle
          skeleton.FGArm.AngularVel = ToAHuman(actor).FGArm.AngularVel
          local effect = CreateMOSParticle("Acid Puff")
          effect.Pos = skeleton.FGArm.Pos
          effect.Vel = skeleton.FGArm.Vel
          effect.LifeTime = math.random(500, 1500)
          if math.random() > 0.5 then
            effect.HFlipped = true
          end
          MovableMan:AddParticle(effect);
        end
        if ToAHuman(actor).BGArm == nil then
          skeleton.BGArm.ToDelete = true
        else
          skeleton.BGArm.RotAngle = ToAHuman(actor).BGArm.RotAngle
          skeleton.BGArm.AngularVel = ToAHuman(actor).BGArm.AngularVel
          local effect = CreateMOSParticle("Acid Puff")
          effect.Pos = skeleton.BGArm.Pos
          effect.Vel = skeleton.BGArm.Vel
          effect.LifeTime = math.random(500, 1500)
          if math.random() > 0.5 then
            effect.HFlipped = true
          end
          MovableMan:AddParticle(effect);
        end
        if ToAHuman(actor).FGLeg == nil then
          skeleton.FGLeg.ToDelete = true
        else
          skeleton.FGLeg.RotAngle = ToAHuman(actor).FGLeg.RotAngle
          skeleton.FGLeg.AngularVel = ToAHuman(actor).FGLeg.AngularVel
          local effect = CreateMOSParticle("Acid Puff")
          effect.Pos = skeleton.FGLeg.Pos
          effect.Vel = skeleton.FGLeg.Vel
          effect.LifeTime = math.random(500, 1500)
          if math.random() > 0.5 then
            effect.HFlipped = true
          end
          MovableMan:AddParticle(effect);
        end
        if ToAHuman(actor).BGLeg == nil then
          skeleton.BGLeg.ToDelete = true
        else
          skeleton.BGLeg.RotAngle = ToAHuman(actor).BGLeg.RotAngle
          skeleton.BGLeg.AngularVel = ToAHuman(actor).BGLeg.AngularVel
          local effect = CreateMOSParticle("Acid Puff")
          effect.Pos = skeleton.BGLeg.Pos
          effect.Vel = skeleton.BGLeg.Vel
          effect.LifeTime = math.random(500, 1500)
          if math.random() > 0.5 then
            effect.HFlipped = true
          end
          MovableMan:AddParticle(effect);
        end
        local effect = CreateMOSParticle("Acid Puff")
        effect.Pos = skeleton.Pos
        effect.Vel = skeleton.Vel
        effect.LifeTime = math.random(500, 1500)
        if math.random() > 0.5 then
          effect.HFlipped = true
        end
        MovableMan:AddParticle(effect);
        actor.ToDelete = true
      end
    end
    local effect = CreateMOSParticle("Acid Puff")
    effect.Pos = self.Pos + self.Vel
    if actor ~= nil and actor.Health ~= nil then
      effect.Vel = actor.Vel + self.Vel*0.02 + self.Vel * math.random() * -0.05
    else
      effect.Vel = self.Vel*0.02 + self.Vel * math.random() * -0.05
    end
    effect.LifeTime = math.random(500, 1500)
    if math.random() > 0.5 then
      effect.HFlipped = true
    end
    MovableMan:AddParticle(effect);
    self.ToDelete = true
  end
end

function Create(self)
  self.Absorbed = 0
  self.Vel = self.Vel * math.random(410 , 440) * 0.0025
  DamageAcid(self)
end

function Update(self)
  DamageAcid(self)
  self.HitsMOs = true
end
