function Create(self)
  --You may change following variables to your likings
  self.ParticleMass = 1 --Mass of the projectile fired
  self.ParticleVel = 80 --speed of the projectile fired
  self.RecoilMulti = 1 --if for some reason you need to change the recoil without changing mass or velocity use this
  self.MovementPunisherment = 5 --How much you are punished for moving while firing
  self.BipodOffset = Vector(11, 5) --Where the Bipod is on the gun
  self.PinDepth = 5 --How deep the bipod is stuck into the ground
  self.BipodStanceOffset = Vector(9, -4) --Where the actor is relative to the gun when the gun is pinned
  
  --Don't fiddle with these
  self.OriginalName = self.PresetName
  self.Recoil = 0
  self.RecoilRot = 0
  self.ShootTimer = Timer()
  self.SharpRange = self.SharpLength
  self.PinnedPos = self.Pos + self:RotateOffset(self.BipodOffset)
  self.PinnedFlipped = self.HFlipped
  self.PickedUp = false
  self.AgeCheck = 0
  self.Clicked = false
end

function Update(self)
  if self.AgeCheck + 100 < self.Age then
    self.PresetName = self.OriginalName
  end
  self.AgeCheck = self.Age
  local negatore = 1
	if self.HFlipped then
		negatore = -1;
	end
  if self.RotAngle < 0 then
     self.RotAngle = self.RotAngle + math.pi * 2
  else
    if self.RotAngle > math.pi * 2 then
       self.RotAngle = self.RotAngle - math.pi * 2
    end
  end
	local Pinstrength = 0
	--If Pinned check current strength of the terrain the gun is pinned on
	if self.PresetName == self.OriginalName .. " (Pinned)" then
    local strikePoint = Vector(0,0);
    local lastPoint = Vector(0,0);
    Pinstrength = SceneMan:CastStrengthSumRay(self.PinnedPos, self.PinnedPos + Vector(-1, self.PinDepth) , 0, 0) + SceneMan:CastStrengthSumRay(self.PinnedPos, self.PinnedPos + Vector(0, self.PinDepth) , 0, 0) + SceneMan:CastStrengthSumRay(self.PinnedPos, self.PinnedPos + Vector(1, self.PinDepth) , 0, 0);
    if Pinstrength < 10*self.PinDepth+self.Recoil*10*self.PinDepth  then
      self.PresetName = self.OriginalName
    end
	end
	
	self.Recoil = self.Recoil * 0.99
	self.RecoilRot = self.RecoilRot * 0.98
	local RecoilReduction = 0.1
	local user = nil
	for parent in MovableMan.Actors do
		if parent.ID == self.RootID then
			user = ToAHuman(parent)
			break
		end
	end
	if user ~= nil then
    --Taking the user into account
    local ArmCount = 0
    local ArmLength = 0
    if user.FGArm ~= nil then
      RecoilReduction = RecoilReduction + user.FGArm.Mass
      ArmCount = ArmCount + 1
      ArmLength = user.FGArm.Diameter
    end
    if user.BGArm ~= nil then
      RecoilReduction = RecoilReduction + user.BGArm.Mass
      ArmCount = ArmCount + 1
      ArmLength = math.max(user.BGArm.Diameter , ArmLength)
    end
    ArmLength = ArmLength + user.Diameter
    local strikePoint = Vector(0,0);
    local lastPoint = Vector(0,0);
    local dist = SceneMan:CastObstacleRay(self.Pos + self:RotateOffset(self.BipodOffset), Vector(0, user.Height * 0.5) , strikePoint, lastPoint, user.ID, -1, 0);
    if dist < 0 then
      dist = user.Height * 0.5
    end
    
    --Regaining control
    local MovementMulti = ((ArmLength/self.MovementPunisherment - math.min(user.Vel.Magnitude , ArmLength/self.MovementPunisherment))/ArmLength*self.MovementPunisherment)
    if self.RecoilRot > 0.01 * MovementMulti^2 then
      self.RecoilRot = self.RecoilRot - 0.01 * MovementMulti^2 * (100+user.Health)/200
    else
      if self.RecoilRot < -0.01 * MovementMulti^2 then
        self.RecoilRot = self.RecoilRot + 0.01 * MovementMulti^2 * (100+user.Health)/200
      else
        self.RecoilRot =  0
      end
    end
    if self.Recoil > 0.02 * MovementMulti^2 then
      self.Recoil = self.Recoil - 0.02 * MovementMulti^2
    else
      self.Recoil =  0
    end
    
    RecoilReduction = (RecoilReduction * user.Mass)^0.5 * ((user.Height * 0.5 - dist + 500)*0.002) + Pinstrength*0.02 * (0.25 + MovementMulti*0.75)
    if self.Diameter > user.Diameter then --if the user is shorter than the gun, make it extra important to have an extra arm for support
      RecoilReduction = RecoilReduction * ArmCount * 0.5
    end
    --[[
    if (self.Recoil > 2.5 or self.Recoil < -2.5) or (self.RecoilRot > 1 or self.RecoilRot < -1) then
      if not self.HFlipped then
        user:GetController():SetState(Controller.MOVE_LEFT, true)
        user:GetController():SetState(Controller.MOVE_RIGHT, false)
      else
        user:GetController():SetState(Controller.MOVE_LEFT, false)
        user:GetController():SetState(Controller.MOVE_RIGHT, true)
      end
    end
    ]]--
    if (self.Recoil > 3.5 or self.Recoil < -3.5) or (self.RecoilRot > 2 or self.RecoilRot < -2) then
      user:GetController():SetState(Controller.BODY_CROUCH,true)
    end
    if (self.Recoil > 4.5 or self.Recoil < -4.5) or (self.RecoilRot > 3 or self.RecoilRot < -3) then
      user:GetController():SetState(Controller.WEAPON_DROP,true)
    end
    if self.PickedUp == false then
      if self.HFlipped ~= self.PinnedFlipped then
        self.PresetName = self.OriginalName
      end
    end
    if self.PresetName == self.OriginalName .. " (Pinned)" then
      local pinnedNegatore = 1
      if user.HFlipped ~= self.PinnedFlipped then
        self:Deactivate()
        user:GetController():SetState(Controller.AIM_SHARP, false)
        pinnedNegatore = -1
      end
      self.HFlipped = self.PinnedFlipped
      if SceneMan:ShortestDistance(self.Pos + self:RotateOffset(self.BipodOffset), self.PinnedPos, SceneMan.SceneWrapsX).Magnitude > self.Diameter*2 then
        self.PresetName = self.OriginalName
      else
        if self.RotAngle > math.pi*0.25 and self.RotAngle < math.pi then
          self.RotAngle = math.pi*0.25
        else
          if self.RotAngle > math.pi*0.25 and self.RotAngle < math.pi*1.75 then
            self.RotAngle = math.pi*1.75
          end
        end
        self.RotAngle = self.RotAngle * pinnedNegatore + self.RecoilRot * negatore * 0.1
        self.Pos = self.PinnedPos - self:RotateOffset(self.BipodOffset)
        self.Vel = Vector(0, 0)
        user.Pos = self.Pos - self:RotateOffset(self.BipodStanceOffset)
        user.Vel = Vector(0, 0)
        altitude = user:GetAltitude(user.Height,0)
        if altitude >= user.Height*0.5 then
          if self.PickedUp == false then
            self.PresetName = self.OriginalName
          else
            user:GetController():SetState(Controller.WEAPON_DROP,true)
          end
        end
      end
    end
    if self.Sharpness == 2 then
      if self.PresetName == self.OriginalName then
        self.PresetName = self.OriginalName .. " (Pinned)"
        local strikePoint = Vector(0,0);
        local lastPoint = Vector(0,0);
        local dist = SceneMan:CastObstacleRay(self.Pos + self:RotateOffset(self.BipodOffset), Vector(0, self.PinDepth) , strikePoint, lastPoint, user.ID, -1, 0);
        if dist >= 0 then
          self.PinnedPos = self.Pos + self:RotateOffset(self.BipodOffset) + Vector(0, dist)
        end
        self.PinnedFlipped = self.HFlipped
      else
        self.PresetName = self.OriginalName
      end
      self.Sharpness = 1
    end
    self.PickedUp = true
  else
    self.PickedUp = false
    self.RecoilRot = 0
    if self.PresetName == self.OriginalName .. " (Pinned)" then
      self.HFlipped = self.PinnedFlipped
      self.Pos = self.PinnedPos - self:RotateOffset(self.BipodOffset)
    end
  end
  if self.Magazine ~= nil then
    if self:IsActivated() then
      if self.Magazine.RoundCount > 0 and self.ShootTimer:IsPastSimMS(60000/self.RateOfFire) and (self.Clicked or self.FullAuto) then
        self.ShootTimer:Reset()
        self.Recoil = self.Recoil + (self.ParticleMass * self.ParticleVel / RecoilReduction)^4 * self.RecoilMulti
        self.RecoilRot = math.random(-self.Recoil , self.Recoil)
        self.Clicked = false
      end
    else
      self.Clicked = true
    end
  else
    self.ShootTimer:Reset()
  end
	if user ~= nil then
    self.SharpLength = self.SharpRange - (self.Recoil*self.SharpRange) * 0.3 + ((math.random(-self.Recoil*(100 - user.Health)^3, self.Recoil*(100 - user.Health)^3)*0.0000005)^2*self.SharpRange)
    self.RotAngle = self.RotAngle + self.RecoilRot * negatore * 0.1 + (math.random(-self.Recoil*(100 - user.Health)^4, self.Recoil*(100 - user.Health)^4)*0.000000005)^2
  end
end

function Destroy(self)

end