function Create(self)
  self.LastUser = nil
  self.LastUserArmLength = 0
  self.LastUserMass = 0
  self.MaxWeight = 300
  self.AbseluteMaxWeight = 500
  self.DetonationTime = 3000
  self.MaxDistance = 150 --the maximum distance the device can teleport an overweighted actor
  self.MaxDistanceReduction = 5 --a multiplier for how much the maxdistance is affected by additional weight.

  self.OriginalName = self.PresetName
  self.PresetName = self.OriginalName .. " (3 sec)"
end

function Update(self)
  if self.Sharpness ~= 1 then
    if self.Sharpness == 2 then
      self.DetonationTime = 1000
      self.MaxWeight = 150
      self.PresetName = self.OriginalName .. " (1 sec)"
    end
    if self.Sharpness == 3 then
      self.DetonationTime = 3000
      self.MaxWeight = 200
      self.PresetName = self.OriginalName .. " (3 sec)"
    end
    if self.Sharpness == 4 then
      self.DetonationTime = 8000
      self.MaxWeight = 300
      self.PresetName = self.OriginalName .. " (8 sec)"
    end
    self.Sharpness = 1
  end
	if self.Fuze then
		if self.Fuze:IsPastSimMS(self.DetonationTime) then
      if self.LastUser ~= nil then
        local gib = false
        local i = math.floor(self.LastUser.Diameter^2/80)
        local dist = SceneMan:ShortestDistance(self.LastUser.Pos, self.Pos, true)
        self.LastUserMass = self.LastUser.Mass
        if self.LastUserMass > self.MaxWeight then
          if self.MaxDistance - (self.LastUserMass*self.MaxDistanceReduction-self.MaxWeight*(1+self.MaxDistanceReduction)) > 0 then
            dist = dist.Normalized * math.min(dist.Magnitude , self.MaxDistance - (self.LastUserMass*self.MaxDistanceReduction-self.MaxWeight*(1+self.MaxDistanceReduction))) + Vector(math.random(-50,50),math.random(-50,50))
            local check = false
            local lasthit = Vector(0,0)
            local testdist = SceneMan:CastStrengthRay(self.Pos + dist, Vector(0,10) , 10, lasthit, 0, -1, true);
            if testdist then
              check = true
            end
            local testdist = SceneMan:CastStrengthRay(self.Pos + dist, Vector(0,-10) , 10, lasthit, 0, -1, true);
            if testdist then
              if check then
                gib = true
              end
            end
          else
            dist = Vector(0,0) + Vector(math.random(-50,50),math.random(-50,50))
          end
        end
        while i > 0 do
          i = i - 1
          local fxa = CreateMOPixel("Teleporter effect");
          local random = math.random(0, math.pi * 200)*0.01
          local randomDiameter = math.random()*self.LastUser.Diameter
          local random2 = math.random()+0.2
          fxa.Pos = self.LastUser.Pos + Vector(math.cos(random), math.sin(random))*math.random(0, randomDiameter * 100) * 0.01
          fxa.Vel = dist*random2/50
          fxa.Lifetime = math.random(500*(2-random2) , 750*(1.75-random2))
          MovableMan:AddParticle(fxa);
        end
        self.LastUser.Pos = self.LastUser.Pos + dist
        local fxa = CreateAEmitter("Teleporter Effect B");
        fxa.Pos = self.LastUser.Pos;
        MovableMan:AddParticle(fxa);
        local i = math.floor(self.LastUser.Diameter^2/80)
        while i > 0 do
          i = i - 1
          local fxa = CreateMOPixel("Teleporter effect");
          local random = math.random(0, math.pi * 200)*0.01
          local randomDiameter = math.random()*self.LastUser.Diameter
          local random2 = math.random()+0.2
          fxa.Pos = self.LastUser.Pos + Vector(math.cos(random), math.sin(random))*math.random(0, randomDiameter * 100) * 0.01 - dist * 0.02
          fxa.Vel = dist.Normalized *dist.Magnitude^0.5*random2/50
          fxa.Lifetime = math.random(500*(2-random2) , 750*(1.75-random2))
          MovableMan:AddParticle(fxa);
        end
        if gib then
          self.LastUser:GibThis()
        end
      end
			self.ToDelete = true
		end
	else
    local user = nil
    for parent in MovableMan.Actors do
      if parent.ID == self.RootID then
        user = ToAHuman(parent)
        break
      end
    end
    if user ~= nil then
      self.LastUser = user
      self.LastUserMass = user.Mass
      if user.FGArm ~= nil then
        self.LastUserArmLength = user.FGArm.Diameter
      end
      if self.LastUserMass > self.MaxWeight and self.LastUser:IsPlayerControlled() then
        if self.LastUserMass > self.AbseluteMaxWeight then
          FrameMan:SetScreenText("\nDanger you are too heavy, drop something.\n", self.LastUser.Team, 333, 10000, true)
        else
          FrameMan:SetScreenText("\nDanger you are too heavy, switch to a longer delay.\n", self.LastUser.Team, 333, 10000, true)
        end
      end
    end
    if self:IsActivated() then
      if user == nil then
        self.LastUserMass = math.max(1 , self.LastUserMass)
        if (self.Vel-self.LastUser.Vel).Magnitude * self.LastUserArmLength/20 - 200*self.Mass / self.LastUserMass > 0 then
          self.Vel = self.LastUser.Vel + (self.Vel-self.LastUser.Vel) * self.LastUserArmLength/20 - (self.Vel-self.LastUser.Vel).Normalized / self.LastUserMass * 200*self.Mass
        else
          self.Vel = self.LastUser.Vel
        end
        self.Fuze = Timer()
      end
      self.LastUserMass = self.LastUser.Mass
      if self.LastUser.Head ~= nil then
        self.LastUserMass = self.LastUserMass + self.LastUser.Head.Mass
      end
      if self.LastUser.FGArm ~= nil then
        self.LastUserMass = self.LastUserMass + self.LastUser.FGArm.Mass
      end
      if self.LastUser.BGArm ~= nil then
        self.LastUserMass = self.LastUserMass + self.LastUser.BGArm.Mass
      end
      if self.LastUser.FGLeg ~= nil then
        self.LastUserMass = self.LastUserMass + self.LastUser.FGLeg.Mass
      end
      if self.LastUser.BGLeg ~= nil then
        self.LastUserMass = self.LastUserMass + self.LastUser.BGLeg.Mass
      end
    end
  end
end